<?php
/***
Archivo descargado de http://willy.tiperu.com/
***/
//Iniciamos o continuamos la sesin encargada de evitar el bucle infinito
session_name("url_amigable");
session_start();
//Almacenamos datos del server, script y variables (pasadas por GET)
$Server=$_SERVER['SERVER_NAME'];
$Script=$_SERVER['PHP_SELF'];
$Variables=$_SERVER['QUERY_STRING'];

//Verificando si tiene variables por GET 
//y no se han pasado datos mediante un form por POST
//ya q al redireccionar un  post puede ocasionar errores.
//Tambien verificamos que la variable de sesin 'Listo' 
//sea diferente a 1, esto nos eviara un bucle infinito.

if(!empty($Variables) && $_SERVER['REQUEST_METHOD']=='GET' && $_SESSION['Listo']!=1){ 
	//Si tiene variables pasadas por GET se procede a hacer el cambio.
	//1. Agrupando $Variables por "variable=valor" en el array $Variable.
	$Variable=explode("&",$Variables);
	//2. Sustituyendo "=" por "," y concadenandolo en variable $Amigable.
	for($i=0;$i<count($Variable);$i++){
		$Amigable.="/".str_replace("=",",",$Variable[$i]);
	}
	//3. Quitando la extension ".php" a $Script para simular un directorio.
	$Dir=str_replace(".php","",$Script);
	//4. Generando la URL Amigable.
	$URL_AMIGABLE="http://".$Server.$Dir.$Amigable."/";
	//5. Colocando la variable de sesin 'Listo' a 1 para evitar el bucle infinito
	// al redireccionar la web.
	$_SESSION['Listo']=1;
	//6. Redireccionando a la url amigable
	header("Location: $URL_AMIGABLE");
	//7. Exit har que culmine hasta este punto el script, si no estuviera 'exit'
	// el script continuara ejecutndose y llegara hasta el final del mismo, es decir,
	// a la parte donde colocamos a la variable de sesin 'Listo' en cero, originandose 
	// entonces un bucle infinito.
	exit;
}
//Cambie $_URL_BASE por la ruta raiz de su web, ya que al simular la url amigable
//directorios, har que no muestre adecuadamente los origenes de los recursos que 
//llama su pgina web.
$_URL_BASE="http://".$Server."/pruebas/url_amigable/index.php";
?>
<html>
<head>
<title>URL Amigables</title>
<base href="<? echo $_URL_BASE;?>" target="_top" />
</head>
<body>
<p><strong>Aqui las urls extensas (El script php hace el cambio por s&iacute; solo) </strong></p>
<p> P&aacute;gina sin variables: <a href="./index.php">./index.php</a>
  <br />
  P&aacute;gina con 1 variable: <a href="./index.php?categoria=monitores">./index.php?categoria=monitores</a>
  <br />
  P&aacute;gina con 2 variables: <a href="./index.php?categoria=monitores&productoID=12345">./index.php?categoria=monitores&amp;productoID=12345</a> 
  <br />
  P&aacute;gina con 3 variables: <a href="./index.php?categoria=monitores&productoID=12345&color=negro">./index.php?categoria=monitores&amp;productoID=12345&amp;color=negro</a>
  <br />
  P&aacute;gina con 4 variables: <a href="./index.php?categoria=monitores&productoID=12345&color=negro&marca=TIperu">./index.php?categoria=monitores&amp;productoID=12345&amp;color=negro&amp;marca=TIPeru</a></p>
<p><strong>Aqu&iacute; como los cambia el php:</strong></p>
<p>P&aacute;gina con 1 variable: <a href="./index.php?categoria=monitores"></a> ./index/categoria,monitores/<br />
P&aacute;gina con 2 variables: <a href="./index.php?categoria=monitores&productoID=12345"></a> ./index/categoria,monitores/productoID,12345/<br />
P&aacute;gina con 3 variables: <a href="./index.php?categoria=monitores&productoID=12345&color=negro"></a> ./index/categoria,monitores/productoID,12345/color,negro/<br />
P&aacute;gina con 4 variables: <a href="./index.php?categoria=monitores&productoID=12345&color=negro&marca=TIperu"></a> ./index/categoria,monitores/productoID,12345/color,negro/marca,TIperu/ </p>
<p><strong>Problemas</strong></p>
<p>Ingresa normal al de 4 variables, con toda y la conversi&oacute;n, pero si refrescas con F5 cuando estas en 4 variables no cargar&aacute; la web, en los dem&aacute;s no hay problema. </p>
</body>
</html>
<?php
//Limpia el Posible Bucle, es decir se puede volver a hacer el envio
$_SESSION['Listo']=0; 
?>